-- Another Wunce Addon! Ask me before borrowing any of my code. (pm me of facepunch)

/*---------------------
	ConVars
---------------------*/
 CreateConVar( "Whud_subsequent_hit_ratio",  0.8, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_initial_hit_ratio", 1, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_recovery_time", 10, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_enabled", 1, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_scifi_realism_mode", 0, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_health_damage_scale", 1, { FCVAR_REPLICATED, FCVAR_ARCHIVE })
 CreateConVar( "Whud_armor_damage_scale", 1, { FCVAR_REPLICATED, FCVAR_ARCHIVE })

 /*--------------------
	Transfer Files
 --------------------*/

 
resource.AddFile( "materials/whud/veins.vtf")
resource.AddFile( "materials/whud/veins.vmt")
resource.AddFile( "materials/whud/redring.vtf")
resource.AddFile( "materials/whud/redring.vmt")
resource.AddFile( "materials/whud/armorbar.vtf")
resource.AddFile( "materials/whud/armorbar.vmt")
resource.AddFile( "materials/whud/armorshield.vtf")
resource.AddFile( "materials/whud/armorshield.vmt")
resource.AddFile( "materials/whud/staticeffect.vtf")
resource.AddFile( "materials/whud/staticeffect.vmt")
resource.AddFile( "materials/whud/hitmar.vtf")
resource.AddFile( "materials/whud/hitmar.vmt")
resource.AddFile( "materials/whud/hitdir.vtf")
resource.AddFile( "materials/whud/hitdir.vmt")

/*------------------------------
	Reset Values on Spawn
------------------------------*/
function whudspawn(ply)
local Whud = GetConVarNumber("Whud_enabled")

	if Whud == 1 then
		ply.lasthittime = CurTime() - 10
		ply.upperbar = ply:Health()
	end
	
end
hook.Add("PlayerSpawn", "whudspawn", whudspawn)
hook.Add("PlayerInitialSpawn", "whudspawninit", whudspawn)



/*------------------------------
	Reduce Upperbar
------------------------------*/
function whuddmg(ply, inf, att, amt, dmginfo)
if ply:IsPlayer() then
 Whud = GetConVarNumber("Whud_enabled")
 scifi = GetConVarNumber("Whud_scifi_realism_mode")
 subhit = GetConVarNumber("Whud_subsequent_hit_ratio")
 inithit = GetConVarNumber("Whud_initial_hit_ratio")
 hpscale = GetConVarNumber("Whud_health_damage_scale")
 armscale = GetConVarNumber("Whud_armor_damage_scale")




if Whud == 1 and scifi == 0 then
	if ply.lasthittime and (ply.lasthittime + 5) >= CurTime() then
		ply.upperbar = subhit*ply.upperbar + (1-subhit)*ply:Health()
		
	elseif ply.lasthittime and (ply.lasthittime + 5) < CurTime() then
		ply.upperbar = inithit*ply.upperbar + (1-inithit)*ply:Health()
		
	end

elseif Whud == 1 and scifi == 1 then
	if ply:Armor() > 0 then
		ply:SetHealth(ply.upperbar) --no more health loss while armored!
	end
end
	
	if ply:Armor() == 0 then
	dmginfo:ScaleDamage(hpscale)
	else
	dmginfo:ScaleDamage(armscale)
	end



	if ply.upperbar and ply.upperbar < 30 then ply.upperbar = 30 end
	ply.lasthittime = CurTime()
	ply.nextregen = nil
		umsg.Start("Fade", ply)
		umsg.Bool(false)
		umsg.End()
		
		local dir = FindAttackLocation(ply, att:GetPos()-ply:GetPos())
		umsg.Start("HitDir", ply)
		umsg.Float(dir)
		umsg.End()

end

if ( ply:IsPlayer() or ply:IsNPC() ) and att:IsPlayer() then
	local dam = amt
		if dam > 100 then dam = 100 end
		umsg.Start("HitMarker", att)
		umsg.Float(dam)
		umsg.End()

end

end
hook.Add("EntityTakeDamage", "whuddmg", whuddmg)

///////////////////////////////////////////		I should give this to the good people of facepunch!
///		Super Critical Fucntion			///
///////////////////////////////////////////
function FindAttackLocation(ply, b) -- I still can't believe I could put my math skills to use

local pi = 3.141592654													
local a = ply:GetAimVector()															
local theta = math.acos(   (a.x * b.x + a.y * b.y) / (math.sqrt(a.x*a.x+a.y*a.y) * math.sqrt(b.x*b.x + b.y* b.y)   ))	
local sign = Vector(a.x,a.y):Cross(Vector(b.x,b.y))			
			   
if sign.z < 0 then
	return 360 - ((180/pi)*theta)
else
	return ((180/pi)*theta)
													
end
end

/*------------------------------
	Regen and recovery
------------------------------*/
function whudthink()
 scifi = GetConVarNumber("Whud_scifi_realism_mode")
 rectime = GetConVarNumber("Whud_recovery_time")
 
	for k,ply in pairs(player.GetAll()) do
	
		if ply.lasthittime and (ply.lasthittime + rectime) < CurTime() and ply.nextregen == nil and ((ply:Health() != ply.upperbar and scifi ==0) or (ply:Armor() < 100 and scifi ==1)) then
			ply.nextregen = CurTime() + 0.1
				umsg.Start("Fade", ply)
				umsg.Bool(true)
				umsg.End()
		end

	if scifi == 0 then
		
		if ply.nextregen and ply.nextregen < CurTime() and ply:Health() < ply.upperbar then
			ply:SetHealth(ply:Health() + 1)
			ply.nextregen = CurTime() + 0.1
		elseif ply.nextregen and ply.nextregen < CurTime() and ply:Health() == ply.upperbar then
			ply.nextregen = nil
		elseif ply.upperbar and ply:Health() > ply.upperbar then
			ply.upperbar = ply:Health()
			ply.nextregen = nil
		end
		
		
	else
	
		if ply.nextregen and ply.nextregen < CurTime() and ply:Armor() < 100 then
			ply:SetArmor(ply:Armor() + 1)
			ply.nextregen = CurTime() + 0.1
			ply.upperbar = ply:Health()
		elseif ply.nextregen and ply.nextregen < CurTime() and ply:Armor() == 100 then
			ply.nextregen = nil
		elseif ply:Armor() > 100 then
			ply:SetArmor(100)
			ply.nextregen = nil
		end

	
	end	
	end
	
end
hook.Add("Think", "whudthink", whudthink)





